Attribute VB_Name = "TDN_SuperficieS"
Option Explicit
'superficies precargadas
Private Type tPrecargadas
    Info() As MapBlock
    Active As Boolean
    Ancho As Integer
    Alto As Integer
End Type
Private Const MAXPRECARGADAS As Integer = 100
Public SuperficiesPC(1 To MAXPRECARGADAS) As tPrecargadas
Public Colocando As Boolean
Private NumSuperficies As Integer
Private Nombre As String
Public xHover As Integer, yHover As Integer
Public Sub LoadPrecarga()
Dim i As Long, X As Long, y As Long, j As Long
NumSuperficies = Val(GetVar(App.Path & "/Precargadas/" & "Config" & ".pre", "Info", "Num"))

For i = 1 To NumSuperficies
    With SuperficiesPC(i)
        .Active = True
        .Ancho = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", "Info", "Width"))
        .Alto = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", "Info", "Height"))
        ReDim .Info(1 To .Ancho, 1 To .Alto) As MapBlock
        Call frmMain.List1.AddItem(GetVar(App.Path & "/Precargadas/" & i & ".pre", "Info", "Nombre"))
        For X = 1 To .Ancho
            For y = 1 To .Alto
                With .Info(X, y)
                    .Blocked = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "Blocked"))
                    .CharIndex = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "CharIndex"))
                    .NPCIndex = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "NPCIndex"))
                    For j = 1 To 4
                        .Graphic(j).GrhIndex = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "g" & j))
                        Call InitGrh(.Graphic(j), .Graphic(j).GrhIndex)
                    Next j
                    .ObjGrh.GrhIndex = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "ObjGrhIndex"))
                    .OBJInfo.objindex = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "ObjIndex"))
                    .OBJInfo.Amount = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "ObjAmount"))
                    .TileExit.Map = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "Map"))
                    .TileExit.X = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "x"))
                    .TileExit.y = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "y"))
                    .Trigger = Val(GetVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "Trigger"))
                End With
            Next y
        Next X
    End With
Next i

End Sub

Public Sub AgregarSuperficiePC(Height As Integer, Width As Integer)
    Dim i As Long, y As Long, X As Long
    For i = 1 To MAXPRECARGADAS
        If Not SuperficiesPC(i).Active Then
            'Encontramos slot
            Nombre = frmMain.Text2.Text
            NumSuperficies = NumSuperficies + 1
            Call WriteVar(App.Path & "/Precargadas/" & "Config" & ".pre", "Info", "Num", CStr(NumSuperficies))
            With SuperficiesPC(i)
                ReDim .Info(1 To Width, 1 To Height) As MapBlock
                For X = 1 To Width
                    For y = 1 To Height
                        .Info(X, y) = SeleccionMap(X, y)
                        .Ancho = Width
                        .Alto = Height
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", "Info", "Width", Width)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", "Info", "Height", Height)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", "Info", "Nombre", Nombre)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "Blocked", .Info(X, y).Blocked)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "CharIndex", .Info(X, y).CharIndex)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "NPCIndex", .Info(X, y).NPCIndex)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "g1", .Info(X, y).Graphic(1).GrhIndex)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "g2", .Info(X, y).Graphic(2).GrhIndex)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "g3", .Info(X, y).Graphic(3).GrhIndex)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "g4", .Info(X, y).Graphic(4).GrhIndex)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "ObjGrhIndex", .Info(X, y).ObjGrh.GrhIndex)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "ObjIndex", .Info(X, y).OBJInfo.objindex)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "ObjAmount", .Info(X, y).OBJInfo.Amount)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "Map", .Info(X, y).TileExit.Map)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "x", .Info(X, y).TileExit.X)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "y", .Info(X, y).TileExit.y)
                        Call WriteVar(App.Path & "/Precargadas/" & i & ".pre", X & "-" & y, "Trigger", .Info(X, y).Trigger)
                    Next y
                Next X
                .Active = True
                Call frmMain.List1.AddItem(Nombre)
            End With
            Exit Sub
        End If
    Next i
End Sub
' [Loopzer]
Public Sub Colocar()
    Dim X As Integer
    Dim y As Integer
    DeSeleccionAncho = SuperficiesPC(frmMain.List1.listIndex + 1).Ancho
    DeSeleccionAlto = SuperficiesPC(frmMain.List1.listIndex + 1).Alto
    SobreX = SobreX - Int(DeSeleccionAncho / 2)
    SobreY = SobreY - Int(DeSeleccionAlto / 2)
    DeSeleccionOX = SobreX
    DeSeleccionOY = SobreY
    For X = 1 To SuperficiesPC(frmMain.List1.listIndex + 1).Ancho
        For y = 1 To SuperficiesPC(frmMain.List1.listIndex + 1).Alto
            With SuperficiesPC(frmMain.List1.listIndex + 1).Info(X, y)
                If .Blocked = 1 Then
                    MapData(X + SobreX, y + SobreY).Blocked = 1
                End If
                If .CharIndex > 0 Then
                    MapData(X + SobreX, y + SobreY).CharIndex = .CharIndex
                End If
                If .NPCIndex > 0 Then
                    MapData(X + SobreX, y + SobreY).NPCIndex = .NPCIndex
                End If
                'las 4 capas
                For i = 1 To 2
                    If .Graphic(i).GrhIndex > 1 Then
                        MapData(X + SobreX, y + SobreY).Graphic(i) = .Graphic(i)
                    End If
                Next i
                MapData(X + SobreX, y + SobreY).Graphic(3) = .Graphic(3) 'esto es para que no se pegoteen los arboles ni los objetos
                MapData(X + SobreX, y + SobreY).Graphic(4) = .Graphic(4)
                MapData(X + SobreX, y + SobreY).ObjGrh = .ObjGrh
                MapData(X + SobreX, y + SobreY).OBJInfo = .OBJInfo
                
                If .TileExit.Map > 0 Then
                    MapData(X + SobreX, y + SobreY).TileExit = .TileExit
                End If
                
                If .Trigger > 0 Then
                    MapData(X + SobreX, y + SobreY).Trigger = .Trigger
                End If
            End With
        Next
    Next
    Colocando = False
End Sub

